// Modules to control application life and create native browser window
const { contextBridge, ipcMain, session, app, BrowserWindow } = require('electron')
const path = require('path')
const fs = require('fs');
const vm = require('vm');
require('./speech');

// const fetch = require('node-fetch');

// // Use a polyfill for fetch
// if (!globalThis.fetch) {
//     globalThis.fetch = fetch;
// }

// const hyphenopolyScript = fs.readFileSync(require.resolve('./Hyphenopoly_Loader.js'), 'utf-8');
// vm.runInThisContext(hyphenopolyScript, { filename: 'Hyphenopoly_Loader.js' });

// Hyphenopoly.config({
//     require: {
//         'en-us': 'FORCEHYPHENOPOLY',
//         'de': 'Silbentrennungsalgorithmus',
//     },
//     paths: {
//         maindir: './',
//         patterndir: './patterns/',
//     },
//     setup: {
//         selectors: {
//             '.hyphenate': {
//                 hyphen: '&shy;',
//             },
//             '.hyphenatePipe': {
//                 hyphen: '|',
//             },
//         },
//     },
// });

// contextBridge.exposeInMainWorld('api', {
//     hyphenateWord: async (word, selector = '.hyphenate') => {
//         const hyphenator = await Hyphenopoly.hyphenators['en-us'];
//         return hyphenator(word, selector);
//     },
// });

const debug = true;

function createWindow () {
  // Create the browser window.
  const mainWindow = new BrowserWindow({
    width: 800,
    height: 600,
    // fullscreen: true,
    // frame: false,
    // titleBarStyle: 'hidden',
    autoHideMenuBar: true,
    webPreferences: {
      nodeIntegration: false,
      contextIsolation: true,
      enableRemoteModule: false,
      // contentSecurityPolicy: "script-src 'self' 'unsafe-inline';",
      preload: path.join(__dirname, 'preload.js')
    }
  })

  if(!debug)
    mainWindow.removeMenu();

  // and load the index.html of the app.
  mainWindow.loadFile('index.html')

  mainWindow.maximize()
  // Open the DevTools.
  // mainWindow.webContents.openDevTools()
}

// This method will be called when Electron has finished
// initialization and is ready to create browser windows.
// Some APIs can only be used after this event occurs.
app.whenReady().then(() => {

  session.defaultSession.webRequest.onHeadersReceived((details, callback) => {
    callback({
      responseHeaders: {
        ...details.responseHeaders,
        'Content-Security-Policy': ['default-src \'self\'; script-src \'self\' \'unsafe-inline\' \'unsafe-eval\' blob:; style-src \'self\' \'unsafe-inline\'']
      }
    })
  })

  createWindow()

  app.on('activate', function () {
    // On macOS it's common to re-create a window in the app when the
    // dock icon is clicked and there are no other windows open.
    if (BrowserWindow.getAllWindows().length === 0) createWindow()
  })
})

// Quit when all windows are closed, except on macOS. There, it's common
// for applications and their menu bar to stay active until the user quits
// explicitly with Cmd + Q.
app.on('window-all-closed', function () {
  if (process.platform !== 'darwin') app.quit()
})

// In this file you can include the rest of your app's specific main process
// code. You can also put them in separate files and require them here.
